﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using System.ServiceModel;
using DevExpress.Xpo;
using DevExpress.Xpo.DB;

using Sturm.XPOUtilities.Contracts;
using Sturm.XPOUtilities.Client;

namespace Client {
  /// <summary>
  /// Interaction logic for App.xaml
  /// </summary>
  public partial class App : Application {
    protected override void OnStartup(StartupEventArgs e) {
      base.OnStartup(e);

      // Get the reference to the remote data store - same as on the server side - 
      // of course this could be done through config files, use different settings etc.
      var binding = new NetTcpBinding(SecurityMode.None);
      var factory = new ChannelFactory<ICacheToCacheCommunicationCoreContract>(binding, 
        "net.tcp://localhost:7465/XPOService");
      var remoteCacheRoot = new CachedDataStoreProxy(factory.CreateChannel( ));

      // Initialize XPO to use that reference
      var cacheNode = new DataCacheNode(remoteCacheRoot);
      XpoDefault.DataLayer = new SimpleDataLayer(cacheNode);
    }
  }
}
