using System;
using DevExpress.Xpo.DB;
using DevExpress.Xpo.DB.Helpers;

using Sturm.XPOUtilities.Contracts;

namespace Sturm.XPOUtilities.Client {
  public class CachedDataStoreProxy : ICacheToCacheCommunicationCore {
    public CachedDataStoreProxy(ICacheToCacheCommunicationCoreContract wrappedContract) {
      this.WrappedContract = wrappedContract;
    }

    public ICacheToCacheCommunicationCoreContract WrappedContract { get; private set; }


    #region ICacheToCacheCommunicationCore Members

    DataCacheModificationResult ICacheToCacheCommunicationCore.ModifyData(DataCacheCookie cookie, ModificationStatement[] dmlStatements) {
      return WrappedContract.ModifyData(cookie, dmlStatements);
    }

    DataCacheResult ICacheToCacheCommunicationCore.NotifyDirtyTables(DataCacheCookie cookie, params string[] dirtyTablesNames) {
      return WrappedContract.NotifyDirtyTables(cookie, dirtyTablesNames);
    }

    DataCacheResult ICacheToCacheCommunicationCore.ProcessCookie(DataCacheCookie cookie) {
      return WrappedContract.ProcessCookie(cookie);
    }

    DataCacheSelectDataResult ICacheToCacheCommunicationCore.SelectData(DataCacheCookie cookie, SelectStatement[] selects) {
      return WrappedContract.SelectData(cookie, selects);
    }

    DataCacheUpdateSchemaResult ICacheToCacheCommunicationCore.UpdateSchema(DataCacheCookie cookie, DBTable[] tables, bool dontCreateIfFirstTableNotExist) {
      return WrappedContract.UpdateSchema(cookie, tables, dontCreateIfFirstTableNotExist);
    }

    #endregion
  }
}
