using System;
using System.ServiceModel;
using DevExpress.Xpo.DB;
using DevExpress.Data.Filtering;
using DevExpress.Xpo.DB.Helpers;

namespace Sturm.XPOUtilities.Contracts {
  [ServiceContract]
  public interface ICacheToCacheCommunicationCoreContract {
    [OperationContract]
    [ServiceKnownType(typeof(InsertStatement))]
    [ServiceKnownType(typeof(DeleteStatement))]
    [ServiceKnownType(typeof(UpdateStatement))]
    [ServiceKnownType(typeof(ContainsOperator))]
    [ServiceKnownType(typeof(BetweenOperator))]
    [ServiceKnownType(typeof(BinaryOperator))]
    [ServiceKnownType(typeof(UnaryOperator))]
    [ServiceKnownType(typeof(InOperator))]
    [ServiceKnownType(typeof(GroupOperator))]
    [ServiceKnownType(typeof(OperandValue))]
    [ServiceKnownType(typeof(ParameterValue))]
    [ServiceKnownType(typeof(OperandProperty))]
    [ServiceKnownType(typeof(AggregateOperand))]
    [ServiceKnownType(typeof(FunctionOperator))]
    [ServiceKnownType(typeof(NotOperator))]
    [ServiceKnownType(typeof(NullOperator))]
    [ServiceKnownType(typeof(QueryOperand))]
    [ServiceKnownType(typeof(QuerySubQueryContainer))]
    DataCacheModificationResult ModifyData(DataCacheCookie cookie,
      ModificationStatement[] dmlStatements);

    [OperationContract]
    DataCacheResult NotifyDirtyTables(DataCacheCookie cookie,
      params string[] dirtyTablesNames);

    [OperationContract]
    DataCacheResult ProcessCookie(DataCacheCookie cookie);

    [OperationContract]
    [ServiceKnownType(typeof(ContainsOperator))]
    [ServiceKnownType(typeof(BetweenOperator))]
    [ServiceKnownType(typeof(BinaryOperator))]
    [ServiceKnownType(typeof(UnaryOperator))]
    [ServiceKnownType(typeof(InOperator))]
    [ServiceKnownType(typeof(GroupOperator))]
    [ServiceKnownType(typeof(OperandValue))]
    [ServiceKnownType(typeof(ParameterValue))]
    [ServiceKnownType(typeof(OperandProperty))]
    [ServiceKnownType(typeof(AggregateOperand))]
    [ServiceKnownType(typeof(FunctionOperator))]
    [ServiceKnownType(typeof(NotOperator))]
    [ServiceKnownType(typeof(NullOperator))]
    [ServiceKnownType(typeof(QueryOperand))]
    [ServiceKnownType(typeof(QuerySubQueryContainer))]
    DataCacheSelectDataResult SelectData(DataCacheCookie cookie, SelectStatement[] selects);

    [OperationContract]
    [ServiceKnownType(typeof(DBColumn))]
    [ServiceKnownType(typeof(DBIndex))]
    [ServiceKnownType(typeof(DBPrimaryKey))]
    DataCacheUpdateSchemaResult UpdateSchema(DataCacheCookie cookie, DBTable[] tables, bool dontCreateIfFirstTableNotExist);

  }
}
