﻿using System;
using System.ServiceModel;
using DevExpress.Xpo.DB;
using DevExpress.Xpo.DB.Helpers;

using Sturm.XPOUtilities.Contracts;


namespace Sturm.XPOUtilities.Server {
  [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
  public class CachedDataStoreProxy : ICacheToCacheCommunicationCoreContract {
    public CachedDataStoreProxy(ICacheToCacheCommunicationCore wrappedCache) {
      this.WrappedCache = wrappedCache;
    }

    public ICacheToCacheCommunicationCore WrappedCache {get;private set;}

    DataCacheModificationResult ICacheToCacheCommunicationCoreContract.ModifyData(DataCacheCookie cookie, ModificationStatement[] dmlStatements) {
      return WrappedCache.ModifyData(cookie, dmlStatements);
    }

    DataCacheResult ICacheToCacheCommunicationCoreContract.NotifyDirtyTables(DataCacheCookie cookie, params string[] dirtyTablesNames) {
      return WrappedCache.NotifyDirtyTables(cookie, dirtyTablesNames);
    }

    DataCacheResult ICacheToCacheCommunicationCoreContract.ProcessCookie(DataCacheCookie cookie) {
      return WrappedCache.ProcessCookie(cookie);
    }

    DataCacheSelectDataResult ICacheToCacheCommunicationCoreContract.SelectData(DataCacheCookie cookie, SelectStatement[] selects) {
      return WrappedCache.SelectData(cookie, selects);
    }

    DataCacheUpdateSchemaResult ICacheToCacheCommunicationCoreContract.UpdateSchema(DataCacheCookie cookie, DBTable[] tables, bool dontCreateIfFirstTableNotExist) {
      return WrappedCache.UpdateSchema(cookie, tables, dontCreateIfFirstTableNotExist);
    }
  }
}
