using System;
using System.ServiceModel;
using DevExpress.Xpo.DB;
using Sturm.XPOUtilities.Contracts;

namespace Sturm.XPOUtilities.Server {
  [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
  public class DataStoreProxy : IDataStoreContract {
    public DataStoreProxy(IDataStore wrappedDataStore) {
      this.WrappedDataStore = wrappedDataStore;
    }

    public IDataStore WrappedDataStore { get; private set; }

    #region IDataStoreContract Members

    AutoCreateOption IDataStoreContract.GetAutoCreateOption( ) {
      return WrappedDataStore.AutoCreateOption;
    }

    ModificationResult IDataStoreContract.ModifyData(params ModificationStatement[] dmlStatements) {
      return WrappedDataStore.ModifyData(dmlStatements);
    }

    SelectedData IDataStoreContract.SelectData(params SelectStatement[] selects) {
      return WrappedDataStore.SelectData(selects);
    }

    UpdateSchemaResult IDataStoreContract.UpdateSchema(bool dontCreateIfFirstTableNotExist, params DBTable[] tables) {
      return WrappedDataStore.UpdateSchema(dontCreateIfFirstTableNotExist, tables);
    }

    #endregion
  }
}
